/* Device.c generated by valac 0.40.7, the Vala compiler
 * generated from Device.vala, do not modify */

/*
 * Copyright (C) 2008,2009 Sebastian Pölsterl
 *
 * This file is part of GNOME DVB Daemon.
 *
 * GNOME DVB Daemon is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME DVB Daemon is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME DVB Daemon.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gudev/gudev.h>
#include <gst/gst.h>


#define DVB_TYPE_ADAPTER_TYPE (dvb_adapter_type_get_type ())

#define DVB_TYPE_DEVICE (dvb_device_get_type ())
#define DVB_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_DEVICE, DVBDevice))
#define DVB_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_DEVICE, DVBDeviceClass))
#define DVB_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_DEVICE))
#define DVB_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_DEVICE))
#define DVB_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_DEVICE, DVBDeviceClass))

typedef struct _DVBDevice DVBDevice;
typedef struct _DVBDeviceClass DVBDeviceClass;
typedef struct _DVBDevicePrivate DVBDevicePrivate;

#define DVB_TYPE_DVB_SRC_DELSYS (dvb_dvb_src_delsys_get_type ())
enum  {
	DVB_DEVICE_0_PROPERTY,
	DVB_DEVICE_ADAPTER_PROPERTY,
	DVB_DEVICE_FRONTEND_PROPERTY,
	DVB_DEVICE_DEV_FILE_PROPERTY,
	DVB_DEVICE_UID_PROPERTY,
	DVB_DEVICE_NAME_PROPERTY,
	DVB_DEVICE_NUM_PROPERTIES
};
static GParamSpec* dvb_device_properties[DVB_DEVICE_NUM_PROPERTIES];

#define DVB_LOGGING_TYPE_LOGGER (dvb_logging_logger_get_type ())
#define DVB_LOGGING_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLogger))
#define DVB_LOGGING_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLoggerClass))
#define DVB_LOGGING_IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_LOGGER))
#define DVB_LOGGING_IS_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_LOGGER))
#define DVB_LOGGING_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLoggerClass))

typedef struct _DVBLoggingLogger DVBLoggingLogger;
typedef struct _DVBLoggingLoggerClass DVBLoggingLoggerClass;

#define DVB_LOGGING_TYPE_LOG_MANAGER (dvb_logging_log_manager_get_type ())
#define DVB_LOGGING_LOG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManager))
#define DVB_LOGGING_LOG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManagerClass))
#define DVB_LOGGING_IS_LOG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_LOG_MANAGER))
#define DVB_LOGGING_IS_LOG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_LOG_MANAGER))
#define DVB_LOGGING_LOG_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManagerClass))

typedef struct _DVBLoggingLogManager DVBLoggingLogManager;
typedef struct _DVBLoggingLogManagerClass DVBLoggingLogManagerClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _gst_message_unref0(var) ((var == NULL) ? NULL : (var = (gst_message_unref (var), NULL)))

typedef enum  {
	DVB_DEVICE_ERROR_UNKNOWN_TYPE
} DVBDeviceError;
#define DVB_DEVICE_ERROR dvb_device_error_quark ()
typedef enum  {
	DVB_ADAPTER_TYPE_UNKNOWN,
	DVB_ADAPTER_TYPE_TERRESTRIAL,
	DVB_ADAPTER_TYPE_SATELLITE,
	DVB_ADAPTER_TYPE_CABLE
} DVBAdapterType;

struct _DVBDevice {
	GObject parent_instance;
	DVBDevicePrivate * priv;
};

struct _DVBDeviceClass {
	GObjectClass parent_class;
};

typedef enum  {
	DVB_DVB_SRC_DELSYS_SYS_UNDEFINED,
	DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_A,
	DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_B,
	DVB_DVB_SRC_DELSYS_SYS_DVBT,
	DVB_DVB_SRC_DELSYS_SYS_DSS,
	DVB_DVB_SRC_DELSYS_SYS_DVBS,
	DVB_DVB_SRC_DELSYS_SYS_DVBS2,
	DVB_DVB_SRC_DELSYS_SYS_DVBH,
	DVB_DVB_SRC_DELSYS_SYS_ISDBT,
	DVB_DVB_SRC_DELSYS_SYS_ISDBS,
	DVB_DVB_SRC_DELSYS_SYS_ISDBC,
	DVB_DVB_SRC_DELSYS_SYS_ATSC,
	DVB_DVB_SRC_DELSYS_SYS_ATSCMH,
	DVB_DVB_SRC_DELSYS_SYS_DTMB,
	DVB_DVB_SRC_DELSYS_SYS_CMMB,
	DVB_DVB_SRC_DELSYS_SYS_DAB,
	DVB_DVB_SRC_DELSYS_SYS_DVBT2,
	DVB_DVB_SRC_DELSYS_SYS_TURBO,
	DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_C
} DVBDvbSrcDelsys;

struct _DVBDevicePrivate {
	guint _Adapter;
	guint _Frontend;
	gchar* _DevFile;
	gchar* _UID;
	gchar* _Name;
	GeeArrayList* delsys;
};


static gpointer dvb_device_parent_class = NULL;
static DVBLoggingLogger* dvb_device_log;
static DVBLoggingLogger* dvb_device_log = NULL;

GQuark dvb_device_error_quark (void);
GType dvb_adapter_type_get_type (void) G_GNUC_CONST;
GType dvb_device_get_type (void) G_GNUC_CONST;
GType dvb_dvb_src_delsys_get_type (void) G_GNUC_CONST;
#define DVB_DEVICE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DVB_TYPE_DEVICE, DVBDevicePrivate))
GType dvb_logging_logger_get_type (void) G_GNUC_CONST;
GType dvb_logging_log_manager_get_type (void) G_GNUC_CONST;
DVBLoggingLogManager* dvb_logging_log_manager_getLogManager (void);
DVBLoggingLogger* dvb_logging_log_manager_getDefaultLogger (DVBLoggingLogManager* self);
#define DVB_DEVICE_PRIME 31
DVBDevice* dvb_device_new (guint adapter,
                           guint frontend);
DVBDevice* dvb_device_construct (GType object_type,
                                 guint adapter,
                                 guint frontend);
static gboolean dvb_device_setAdapterTypeAndName (DVBDevice* self,
                                           guint adapter,
                                           guint frontend);
DVBDevice* dvb_device_new_with_udev (GUdevDevice* device,
                                     const gchar* dev_file,
                                     guint adapter,
                                     guint frontend);
DVBDevice* dvb_device_construct_with_udev (GType object_type,
                                           GUdevDevice* device,
                                           const gchar* dev_file,
                                           guint adapter,
                                           guint frontend);
const gchar* dvb_device_get_Name (DVBDevice* self);
static void dvb_device_set_Name (DVBDevice* self,
                          const gchar* value);
void dvb_logging_logger_debug (DVBLoggingLogger* self,
                               const gchar* format,
                               ...) G_GNUC_PRINTF(2,3);
static void dvb_device_set_DevFile (DVBDevice* self,
                             const gchar* value);
static void dvb_device_set_UID (DVBDevice* self,
                         const gchar* value);
gboolean dvb_device_equal (DVBDevice* dev1,
                           DVBDevice* dev2);
guint dvb_device_get_Adapter (DVBDevice* self);
guint dvb_device_get_Frontend (DVBDevice* self);
guint dvb_device_hash (DVBDevice* device);
guint dvb_device_hash_without_device (guint adapter,
                                      guint frontend);
gboolean dvb_device_isTerrestrial (DVBDevice* self);
gboolean dvb_device_isCable (DVBDevice* self);
gboolean dvb_device_isSatellite (DVBDevice* self);
gboolean dvb_device_isDVB (DVBDevice* self);
gboolean dvb_device_isATSC (DVBDevice* self);
gboolean dvb_device_isISDB (DVBDevice* self);
gboolean dvb_device_isDelsys (DVBDevice* self,
                              DVBDvbSrcDelsys delsys);
gboolean dvb_device_is_busy (DVBDevice* self);
void dvb_logging_logger_error (DVBLoggingLogger* self,
                               const gchar* format,
                               ...) G_GNUC_PRINTF(2,3);
static void dvb_device_set_Adapter (DVBDevice* self,
                             guint value);
static void dvb_device_set_Frontend (DVBDevice* self,
                              guint value);
const gchar* dvb_device_get_DevFile (DVBDevice* self);
const gchar* dvb_device_get_UID (DVBDevice* self);
static void dvb_device_finalize (GObject * obj);
static void _vala_dvb_device_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_dvb_device_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);


GQuark
dvb_device_error_quark (void)
{
	return g_quark_from_static_string ("dvb_device_error-quark");
}


GType
dvb_adapter_type_get_type (void)
{
	static volatile gsize dvb_adapter_type_type_id__volatile = 0;
	if (g_once_init_enter (&dvb_adapter_type_type_id__volatile)) {
		static const GEnumValue values[] = {{DVB_ADAPTER_TYPE_UNKNOWN, "DVB_ADAPTER_TYPE_UNKNOWN", "unknown"}, {DVB_ADAPTER_TYPE_TERRESTRIAL, "DVB_ADAPTER_TYPE_TERRESTRIAL", "terrestrial"}, {DVB_ADAPTER_TYPE_SATELLITE, "DVB_ADAPTER_TYPE_SATELLITE", "satellite"}, {DVB_ADAPTER_TYPE_CABLE, "DVB_ADAPTER_TYPE_CABLE", "cable"}, {0, NULL, NULL}};
		GType dvb_adapter_type_type_id;
		dvb_adapter_type_type_id = g_enum_register_static ("DVBAdapterType", values);
		g_once_init_leave (&dvb_adapter_type_type_id__volatile, dvb_adapter_type_type_id);
	}
	return dvb_adapter_type_type_id__volatile;
}


DVBDevice*
dvb_device_construct (GType object_type,
                      guint adapter,
                      guint frontend)
{
	DVBDevice * self = NULL;
	self = (DVBDevice*) g_object_new (object_type, "Adapter", adapter, "Frontend", frontend, NULL);
	dvb_device_setAdapterTypeAndName (self, adapter, frontend);
	return self;
}


DVBDevice*
dvb_device_new (guint adapter,
                guint frontend)
{
	return dvb_device_construct (DVB_TYPE_DEVICE, adapter, frontend);
}


DVBDevice*
dvb_device_construct_with_udev (GType object_type,
                                GUdevDevice* device,
                                const gchar* dev_file,
                                guint adapter,
                                guint frontend)
{
	DVBDevice * self = NULL;
	GUdevDevice* parent = NULL;
	GUdevDevice* _tmp0_;
	gchar* name = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* tmp = NULL;
	GUdevDevice* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	DVBLoggingLogger* _tmp14_;
	const gchar* _tmp15_;
	GUdevDevice* _tmp16_;
	const gchar* _tmp17_;
	g_return_val_if_fail (device != NULL, NULL);
	g_return_val_if_fail (dev_file != NULL, NULL);
	self = (DVBDevice*) g_object_new (object_type, "Adapter", adapter, "Frontend", frontend, NULL);
	dvb_device_setAdapterTypeAndName (self, adapter, frontend);
	_tmp0_ = g_udev_device_get_parent (device);
	parent = _tmp0_;
	_tmp1_ = self->priv->_Name;
	_tmp2_ = g_strdup (_tmp1_);
	name = _tmp2_;
	_tmp3_ = parent;
	_tmp4_ = g_udev_device_get_property (_tmp3_, "ID_MODEL_FROM_DATABASE");
	_tmp5_ = g_strdup (_tmp4_);
	tmp = _tmp5_;
	_tmp6_ = tmp;
	if (_tmp6_ == NULL) {
		const gchar* _tmp7_;
		_tmp7_ = name;
		dvb_device_set_Name (self, _tmp7_);
	} else {
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		_tmp8_ = tmp;
		_tmp9_ = g_strconcat (_tmp8_, ": ", NULL);
		_tmp10_ = _tmp9_;
		_tmp11_ = name;
		_tmp12_ = g_strconcat (_tmp10_, _tmp11_, NULL);
		_tmp13_ = _tmp12_;
		dvb_device_set_Name (self, _tmp13_);
		_g_free0 (_tmp13_);
		_g_free0 (_tmp10_);
	}
	_tmp14_ = dvb_device_log;
	_tmp15_ = self->priv->_Name;
	dvb_logging_logger_debug (_tmp14_, "Device.vala:75: Adding Device: %s", _tmp15_);
	dvb_device_set_DevFile (self, dev_file);
	_tmp16_ = parent;
	_tmp17_ = g_udev_device_get_subsystem (_tmp16_);
	if (g_strcmp0 (_tmp17_, "pci") == 0) {
		gchar* uid = NULL;
		GUdevDevice* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		const gchar* _tmp21_;
		GUdevDevice* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		DVBLoggingLogger* _tmp32_;
		const gchar* _tmp33_;
		const gchar* _tmp34_;
		_tmp18_ = parent;
		_tmp19_ = g_udev_device_get_property (_tmp18_, "PCI_SLOT_NAME");
		_tmp20_ = g_strdup (_tmp19_);
		uid = _tmp20_;
		_tmp21_ = uid;
		_tmp22_ = parent;
		_tmp23_ = g_udev_device_get_property (_tmp22_, "PCI_SUBSYS_ID");
		_tmp24_ = g_strconcat (":", _tmp23_, NULL);
		_tmp25_ = _tmp24_;
		_tmp26_ = g_strconcat (_tmp21_, _tmp25_, NULL);
		_g_free0 (uid);
		uid = _tmp26_;
		_g_free0 (_tmp25_);
		_tmp27_ = uid;
		_tmp28_ = name;
		_tmp29_ = g_strconcat (":", _tmp28_, NULL);
		_tmp30_ = _tmp29_;
		_tmp31_ = g_strconcat (_tmp27_, _tmp30_, NULL);
		_g_free0 (uid);
		uid = _tmp31_;
		_g_free0 (_tmp30_);
		_tmp32_ = dvb_device_log;
		_tmp33_ = uid;
		dvb_logging_logger_debug (_tmp32_, "Device.vala:84: UID: %s", _tmp33_);
		_tmp34_ = uid;
		dvb_device_set_UID (self, _tmp34_);
		_g_free0 (uid);
	} else {
		GUdevDevice* _tmp35_;
		const gchar* _tmp36_;
		_tmp35_ = parent;
		_tmp36_ = g_udev_device_get_subsystem (_tmp35_);
		if (g_strcmp0 (_tmp36_, "usb") == 0) {
			gchar* uid = NULL;
			GUdevDevice* _tmp37_;
			const gchar* _tmp38_;
			gchar* _tmp39_;
			const gchar* _tmp40_;
			const gchar* _tmp41_;
			gchar* _tmp42_;
			gchar* _tmp43_;
			gchar* _tmp44_;
			DVBLoggingLogger* _tmp45_;
			const gchar* _tmp46_;
			const gchar* _tmp47_;
			_tmp37_ = parent;
			_tmp38_ = g_udev_device_get_property (_tmp37_, "ID_SERIAL");
			_tmp39_ = g_strdup (_tmp38_);
			uid = _tmp39_;
			_tmp40_ = uid;
			_tmp41_ = name;
			_tmp42_ = g_strconcat (":", _tmp41_, NULL);
			_tmp43_ = _tmp42_;
			_tmp44_ = g_strconcat (_tmp40_, _tmp43_, NULL);
			_g_free0 (uid);
			uid = _tmp44_;
			_g_free0 (_tmp43_);
			_tmp45_ = dvb_device_log;
			_tmp46_ = uid;
			dvb_logging_logger_debug (_tmp45_, "Device.vala:89: UID: %s", _tmp46_);
			_tmp47_ = uid;
			dvb_device_set_UID (self, _tmp47_);
			_g_free0 (uid);
		}
	}
	_g_free0 (tmp);
	_g_free0 (name);
	_g_object_unref0 (parent);
	return self;
}


DVBDevice*
dvb_device_new_with_udev (GUdevDevice* device,
                          const gchar* dev_file,
                          guint adapter,
                          guint frontend)
{
	return dvb_device_construct_with_udev (DVB_TYPE_DEVICE, device, dev_file, adapter, frontend);
}


gboolean
dvb_device_equal (DVBDevice* dev1,
                  DVBDevice* dev2)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	guint _tmp2_;
	guint _tmp3_;
	g_return_val_if_fail (dev1 != NULL, FALSE);
	g_return_val_if_fail (dev2 != NULL, FALSE);
	if (dev1 == NULL) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = dev2 == NULL;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp2_ = dev1->priv->_Adapter;
	_tmp3_ = dev2->priv->_Adapter;
	if (_tmp2_ == _tmp3_) {
		guint _tmp4_;
		guint _tmp5_;
		_tmp4_ = dev1->priv->_Frontend;
		_tmp5_ = dev2->priv->_Frontend;
		_tmp1_ = _tmp4_ == _tmp5_;
	} else {
		_tmp1_ = FALSE;
	}
	result = _tmp1_;
	return result;
}


guint
dvb_device_hash (DVBDevice* device)
{
	guint result = 0U;
	guint _tmp0_;
	guint _tmp1_;
	g_return_val_if_fail (device != NULL, 0U);
	if (device == NULL) {
		result = (guint) 0;
		return result;
	}
	_tmp0_ = device->priv->_Adapter;
	_tmp1_ = device->priv->_Frontend;
	result = dvb_device_hash_without_device (_tmp0_, _tmp1_);
	return result;
}


guint
dvb_device_hash_without_device (guint adapter,
                                guint frontend)
{
	guint result = 0U;
	result = ((2 * DVB_DEVICE_PRIME) + (DVB_DEVICE_PRIME * adapter)) + frontend;
	return result;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


gboolean
dvb_device_isTerrestrial (DVBDevice* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		GeeArrayList* _delsys_list = NULL;
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _delsys_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _delsys_index = 0;
		_tmp0_ = self->priv->delsys;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_delsys_list = _tmp1_;
		_tmp2_ = _delsys_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_delsys_size = _tmp4_;
		_delsys_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			DVBDvbSrcDelsys delsys = 0;
			GeeArrayList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			DVBDvbSrcDelsys _tmp11_;
			_tmp5_ = _delsys_index;
			_delsys_index = _tmp5_ + 1;
			_tmp6_ = _delsys_index;
			_tmp7_ = _delsys_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _delsys_list;
			_tmp9_ = _delsys_index;
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
			delsys = (DVBDvbSrcDelsys) ((gintptr) _tmp10_);
			_tmp11_ = delsys;
			switch (_tmp11_) {
				case DVB_DVB_SRC_DELSYS_SYS_DVBT:
				case DVB_DVB_SRC_DELSYS_SYS_DVBT2:
				case DVB_DVB_SRC_DELSYS_SYS_DVBH:
				case DVB_DVB_SRC_DELSYS_SYS_ATSC:
				case DVB_DVB_SRC_DELSYS_SYS_ATSCMH:
				case DVB_DVB_SRC_DELSYS_SYS_ISDBT:
				{
					result = TRUE;
					_g_object_unref0 (_delsys_list);
					return result;
				}
				default:
				{
					break;
				}
			}
		}
		_g_object_unref0 (_delsys_list);
	}
	result = FALSE;
	return result;
}


gboolean
dvb_device_isCable (DVBDevice* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		GeeArrayList* _delsys_list = NULL;
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _delsys_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _delsys_index = 0;
		_tmp0_ = self->priv->delsys;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_delsys_list = _tmp1_;
		_tmp2_ = _delsys_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_delsys_size = _tmp4_;
		_delsys_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			DVBDvbSrcDelsys delsys = 0;
			GeeArrayList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			DVBDvbSrcDelsys _tmp11_;
			_tmp5_ = _delsys_index;
			_delsys_index = _tmp5_ + 1;
			_tmp6_ = _delsys_index;
			_tmp7_ = _delsys_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _delsys_list;
			_tmp9_ = _delsys_index;
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
			delsys = (DVBDvbSrcDelsys) ((gintptr) _tmp10_);
			_tmp11_ = delsys;
			switch (_tmp11_) {
				case DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_A:
				case DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_B:
				case DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_C:
				case DVB_DVB_SRC_DELSYS_SYS_ISDBC:
				{
					result = TRUE;
					_g_object_unref0 (_delsys_list);
					return result;
				}
				default:
				{
					break;
				}
			}
		}
		_g_object_unref0 (_delsys_list);
	}
	result = FALSE;
	return result;
}


gboolean
dvb_device_isSatellite (DVBDevice* self)
{
	gboolean result = FALSE;
	gboolean ret = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	ret = FALSE;
	{
		GeeArrayList* _delsys_list = NULL;
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _delsys_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _delsys_index = 0;
		_tmp0_ = self->priv->delsys;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_delsys_list = _tmp1_;
		_tmp2_ = _delsys_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_delsys_size = _tmp4_;
		_delsys_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			DVBDvbSrcDelsys delsys = 0;
			GeeArrayList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			DVBDvbSrcDelsys _tmp11_;
			_tmp5_ = _delsys_index;
			_delsys_index = _tmp5_ + 1;
			_tmp6_ = _delsys_index;
			_tmp7_ = _delsys_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _delsys_list;
			_tmp9_ = _delsys_index;
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
			delsys = (DVBDvbSrcDelsys) ((gintptr) _tmp10_);
			_tmp11_ = delsys;
			switch (_tmp11_) {
				case DVB_DVB_SRC_DELSYS_SYS_DVBS:
				case DVB_DVB_SRC_DELSYS_SYS_DVBS2:
				case DVB_DVB_SRC_DELSYS_SYS_ISDBS:
				case DVB_DVB_SRC_DELSYS_SYS_DSS:
				case DVB_DVB_SRC_DELSYS_SYS_TURBO:
				{
					result = TRUE;
					_g_object_unref0 (_delsys_list);
					return result;
				}
				default:
				{
					break;
				}
			}
		}
		_g_object_unref0 (_delsys_list);
	}
	result = ret;
	return result;
}


gboolean
dvb_device_isDVB (DVBDevice* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		GeeArrayList* _delsys_list = NULL;
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _delsys_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _delsys_index = 0;
		_tmp0_ = self->priv->delsys;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_delsys_list = _tmp1_;
		_tmp2_ = _delsys_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_delsys_size = _tmp4_;
		_delsys_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			DVBDvbSrcDelsys delsys = 0;
			GeeArrayList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			DVBDvbSrcDelsys _tmp11_;
			_tmp5_ = _delsys_index;
			_delsys_index = _tmp5_ + 1;
			_tmp6_ = _delsys_index;
			_tmp7_ = _delsys_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _delsys_list;
			_tmp9_ = _delsys_index;
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
			delsys = (DVBDvbSrcDelsys) ((gintptr) _tmp10_);
			_tmp11_ = delsys;
			switch (_tmp11_) {
				case DVB_DVB_SRC_DELSYS_SYS_DVBT:
				case DVB_DVB_SRC_DELSYS_SYS_DVBT2:
				case DVB_DVB_SRC_DELSYS_SYS_DVBS:
				case DVB_DVB_SRC_DELSYS_SYS_DVBS2:
				case DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_A:
				case DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_C:
				case DVB_DVB_SRC_DELSYS_SYS_DVBH:
				{
					result = TRUE;
					_g_object_unref0 (_delsys_list);
					return result;
				}
				default:
				{
					break;
				}
			}
		}
		_g_object_unref0 (_delsys_list);
	}
	result = FALSE;
	return result;
}


gboolean
dvb_device_isATSC (DVBDevice* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		GeeArrayList* _delsys_list = NULL;
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _delsys_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _delsys_index = 0;
		_tmp0_ = self->priv->delsys;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_delsys_list = _tmp1_;
		_tmp2_ = _delsys_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_delsys_size = _tmp4_;
		_delsys_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			DVBDvbSrcDelsys delsys = 0;
			GeeArrayList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			DVBDvbSrcDelsys _tmp11_;
			_tmp5_ = _delsys_index;
			_delsys_index = _tmp5_ + 1;
			_tmp6_ = _delsys_index;
			_tmp7_ = _delsys_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _delsys_list;
			_tmp9_ = _delsys_index;
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
			delsys = (DVBDvbSrcDelsys) ((gintptr) _tmp10_);
			_tmp11_ = delsys;
			switch (_tmp11_) {
				case DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_B:
				case DVB_DVB_SRC_DELSYS_SYS_ATSC:
				case DVB_DVB_SRC_DELSYS_SYS_ATSCMH:
				{
					result = TRUE;
					_g_object_unref0 (_delsys_list);
					return result;
				}
				default:
				{
					break;
				}
			}
		}
		_g_object_unref0 (_delsys_list);
	}
	result = FALSE;
	return result;
}


gboolean
dvb_device_isISDB (DVBDevice* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		GeeArrayList* _delsys_list = NULL;
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _delsys_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _delsys_index = 0;
		_tmp0_ = self->priv->delsys;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_delsys_list = _tmp1_;
		_tmp2_ = _delsys_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_delsys_size = _tmp4_;
		_delsys_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			DVBDvbSrcDelsys delsys = 0;
			GeeArrayList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			DVBDvbSrcDelsys _tmp11_;
			_tmp5_ = _delsys_index;
			_delsys_index = _tmp5_ + 1;
			_tmp6_ = _delsys_index;
			_tmp7_ = _delsys_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _delsys_list;
			_tmp9_ = _delsys_index;
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
			delsys = (DVBDvbSrcDelsys) ((gintptr) _tmp10_);
			_tmp11_ = delsys;
			switch (_tmp11_) {
				case DVB_DVB_SRC_DELSYS_SYS_ISDBT:
				case DVB_DVB_SRC_DELSYS_SYS_ISDBC:
				case DVB_DVB_SRC_DELSYS_SYS_ISDBS:
				{
					result = TRUE;
					_g_object_unref0 (_delsys_list);
					return result;
				}
				default:
				{
					break;
				}
			}
		}
		_g_object_unref0 (_delsys_list);
	}
	result = FALSE;
	return result;
}


gboolean
dvb_device_isDelsys (DVBDevice* self,
                     DVBDvbSrcDelsys delsys)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		GeeArrayList* _d_list = NULL;
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _d_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _d_index = 0;
		_tmp0_ = self->priv->delsys;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_d_list = _tmp1_;
		_tmp2_ = _d_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_d_size = _tmp4_;
		_d_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			DVBDvbSrcDelsys d = 0;
			GeeArrayList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			DVBDvbSrcDelsys _tmp11_;
			_tmp5_ = _d_index;
			_d_index = _tmp5_ + 1;
			_tmp6_ = _d_index;
			_tmp7_ = _d_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _d_list;
			_tmp9_ = _d_index;
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
			d = (DVBDvbSrcDelsys) ((gintptr) _tmp10_);
			_tmp11_ = d;
			if (_tmp11_ == delsys) {
				result = TRUE;
				_g_object_unref0 (_d_list);
				return result;
			}
		}
		_g_object_unref0 (_d_list);
	}
	result = FALSE;
	return result;
}


gboolean
dvb_device_is_busy (DVBDevice* self)
{
	gboolean result = FALSE;
	GstElement* dvbsrc = NULL;
	GstElement* _tmp0_;
	GstElement* _tmp1_;
	GstElement* _tmp3_;
	guint _tmp4_;
	GstElement* _tmp5_;
	guint _tmp6_;
	GstElement* pipeline = NULL;
	GstPipeline* _tmp7_;
	GstElement* _tmp8_;
	GstElement* _tmp9_;
	GstElement* _tmp10_;
	GstBus* bus = NULL;
	GstElement* _tmp11_;
	GstBus* _tmp12_;
	gboolean busy_val = FALSE;
	GstElement* _tmp29_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = gst_element_factory_make ("dvbsrc", "text_dvbsrc");
	if (_tmp0_ != NULL) {
		g_object_ref_sink (_tmp0_);
	}
	dvbsrc = _tmp0_;
	_tmp1_ = dvbsrc;
	if (_tmp1_ == NULL) {
		DVBLoggingLogger* _tmp2_;
		_tmp2_ = dvb_device_log;
		dvb_logging_logger_error (_tmp2_, "Device.vala:217: Could not create dvbsrc element");
		result = TRUE;
		_g_object_unref0 (dvbsrc);
		return result;
	}
	_tmp3_ = dvbsrc;
	_tmp4_ = self->priv->_Adapter;
	g_object_set ((GObject*) _tmp3_, "adapter", _tmp4_, NULL);
	_tmp5_ = dvbsrc;
	_tmp6_ = self->priv->_Frontend;
	g_object_set ((GObject*) _tmp5_, "frontend", _tmp6_, NULL);
	_tmp7_ = (GstPipeline*) gst_pipeline_new ("");
	g_object_ref_sink (_tmp7_);
	pipeline = (GstElement*) _tmp7_;
	_tmp8_ = pipeline;
	_tmp9_ = dvbsrc;
	gst_bin_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gst_bin_get_type (), GstBin), _tmp9_);
	_tmp10_ = pipeline;
	gst_element_set_state (_tmp10_, GST_STATE_READY);
	_tmp11_ = pipeline;
	_tmp12_ = gst_element_get_bus (_tmp11_);
	bus = _tmp12_;
	busy_val = FALSE;
	while (TRUE) {
		GstBus* _tmp13_;
		GstMessage* msg = NULL;
		GstBus* _tmp14_;
		GstMessage* _tmp15_;
		gboolean _tmp16_ = FALSE;
		GstMessage* _tmp17_;
		GstMessageType _tmp18_;
		_tmp13_ = bus;
		if (!gst_bus_have_pending (_tmp13_)) {
			break;
		}
		_tmp14_ = bus;
		_tmp15_ = gst_bus_pop (_tmp14_);
		msg = _tmp15_;
		_tmp17_ = msg;
		_tmp18_ = _tmp17_->type;
		if (_tmp18_ == GST_MESSAGE_ERROR) {
			GstMessage* _tmp19_;
			GstObject* _tmp20_;
			GstElement* _tmp21_;
			_tmp19_ = msg;
			_tmp20_ = _tmp19_->src;
			_tmp21_ = dvbsrc;
			_tmp16_ = _tmp20_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, gst_object_get_type (), GstObject);
		} else {
			_tmp16_ = FALSE;
		}
		if (_tmp16_) {
			GError* gerror = NULL;
			gchar* debug_text = NULL;
			GstMessage* _tmp22_;
			GError* _tmp23_ = NULL;
			gchar* _tmp24_ = NULL;
			DVBLoggingLogger* _tmp25_;
			GError* _tmp26_;
			const gchar* _tmp27_;
			const gchar* _tmp28_;
			_tmp22_ = msg;
			gst_message_parse_error (_tmp22_, &_tmp23_, &_tmp24_);
			_g_error_free0 (gerror);
			gerror = _tmp23_;
			_g_free0 (debug_text);
			debug_text = _tmp24_;
			_tmp25_ = dvb_device_log;
			_tmp26_ = gerror;
			_tmp27_ = _tmp26_->message;
			_tmp28_ = debug_text;
			dvb_logging_logger_debug (_tmp25_, "Device.vala:239: Error tuning: %s; %s", _tmp27_, _tmp28_);
			busy_val = TRUE;
			_g_free0 (debug_text);
			_g_error_free0 (gerror);
		}
		_gst_message_unref0 (msg);
	}
	_tmp29_ = pipeline;
	gst_element_set_state (_tmp29_, GST_STATE_NULL);
	result = busy_val;
	_g_object_unref0 (bus);
	_g_object_unref0 (pipeline);
	_g_object_unref0 (dvbsrc);
	return result;
}


static gboolean
dvb_device_setAdapterTypeAndName (DVBDevice* self,
                                  guint adapter,
                                  guint frontend)
{
	gboolean result = FALSE;
	GstElement* dvbsrc = NULL;
	GstElement* _tmp0_;
	GstElement* _tmp1_;
	GstElement* _tmp3_;
	GstElement* _tmp4_;
	GstElement* pipeline = NULL;
	GstPipeline* _tmp5_;
	GstElement* _tmp6_;
	GstElement* _tmp7_;
	GstElement* _tmp8_;
	GstBus* bus = NULL;
	GstElement* _tmp9_;
	GstBus* _tmp10_;
	gboolean success = FALSE;
	GeeArrayList* _tmp11_;
	GstElement* _tmp73_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = gst_element_factory_make ("dvbsrc", "test_dvbsrc");
	if (_tmp0_ != NULL) {
		g_object_ref_sink (_tmp0_);
	}
	dvbsrc = _tmp0_;
	_tmp1_ = dvbsrc;
	if (_tmp1_ == NULL) {
		DVBLoggingLogger* _tmp2_;
		_tmp2_ = dvb_device_log;
		dvb_logging_logger_error (_tmp2_, "Device.vala:253: Could not create dvbsrc element");
		result = FALSE;
		_g_object_unref0 (dvbsrc);
		return result;
	}
	_tmp3_ = dvbsrc;
	g_object_set ((GObject*) _tmp3_, "adapter", adapter, NULL);
	_tmp4_ = dvbsrc;
	g_object_set ((GObject*) _tmp4_, "frontend", frontend, NULL);
	_tmp5_ = (GstPipeline*) gst_pipeline_new ("type_name");
	g_object_ref_sink (_tmp5_);
	pipeline = (GstElement*) _tmp5_;
	_tmp6_ = pipeline;
	_tmp7_ = dvbsrc;
	gst_bin_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gst_bin_get_type (), GstBin), _tmp7_);
	_tmp8_ = pipeline;
	gst_element_set_state (_tmp8_, GST_STATE_READY);
	_tmp9_ = pipeline;
	_tmp10_ = gst_element_get_bus (_tmp9_);
	bus = _tmp10_;
	success = FALSE;
	_tmp11_ = gee_array_list_new (DVB_TYPE_DVB_SRC_DELSYS, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->delsys);
	self->priv->delsys = _tmp11_;
	while (TRUE) {
		GstBus* _tmp12_;
		GstMessage* msg = NULL;
		GstBus* _tmp13_;
		GstMessage* _tmp14_;
		gboolean _tmp15_ = FALSE;
		GstMessage* _tmp16_;
		GstMessageType _tmp17_;
		_tmp12_ = bus;
		if (!gst_bus_have_pending (_tmp12_)) {
			break;
		}
		_tmp13_ = bus;
		_tmp14_ = gst_bus_pop (_tmp13_);
		msg = _tmp14_;
		_tmp16_ = msg;
		_tmp17_ = _tmp16_->type;
		if (_tmp17_ == GST_MESSAGE_ELEMENT) {
			GstMessage* _tmp18_;
			GstObject* _tmp19_;
			GstElement* _tmp20_;
			_tmp18_ = msg;
			_tmp19_ = _tmp18_->src;
			_tmp20_ = dvbsrc;
			_tmp15_ = _tmp19_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, gst_object_get_type (), GstObject);
		} else {
			_tmp15_ = FALSE;
		}
		if (_tmp15_) {
			GstStructure* structure = NULL;
			GstMessage* _tmp21_;
			GstStructure* _tmp22_;
			GstStructure* _tmp23_;
			const gchar* _tmp24_;
			_tmp21_ = msg;
			_tmp22_ = gst_message_get_structure (_tmp21_);
			structure = _tmp22_;
			_tmp23_ = structure;
			_tmp24_ = gst_structure_get_name (_tmp23_);
			if (g_strcmp0 (_tmp24_, "dvb-adapter") == 0) {
				GstStructure* _tmp25_;
				const gchar* _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
				GstStructure* _tmp29_;
				GstStructure* _tmp31_;
				GstStructure* _tmp33_;
				GstStructure* _tmp35_;
				GstStructure* _tmp37_;
				GstStructure* _tmp39_;
				GstStructure* _tmp41_;
				GstStructure* _tmp43_;
				GstStructure* _tmp45_;
				GstStructure* _tmp47_;
				GstStructure* _tmp49_;
				GstStructure* _tmp51_;
				GstStructure* _tmp53_;
				GstStructure* _tmp55_;
				GstStructure* _tmp57_;
				GstStructure* _tmp59_;
				GstStructure* _tmp61_;
				GstStructure* _tmp63_;
				_tmp25_ = structure;
				_tmp26_ = gst_structure_get_string (_tmp25_, "name");
				_tmp27_ = g_strdup_printf ("%s", _tmp26_);
				_tmp28_ = _tmp27_;
				dvb_device_set_Name (self, _tmp28_);
				_g_free0 (_tmp28_);
				_tmp29_ = structure;
				if (gst_structure_has_field (_tmp29_, "dvb-c-a")) {
					GeeArrayList* _tmp30_;
					_tmp30_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp30_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_A));
				}
				_tmp31_ = structure;
				if (gst_structure_has_field (_tmp31_, "dvb-c-b")) {
					GeeArrayList* _tmp32_;
					_tmp32_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp32_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_B));
				}
				_tmp33_ = structure;
				if (gst_structure_has_field (_tmp33_, "dvb-t")) {
					GeeArrayList* _tmp34_;
					_tmp34_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp34_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_DVBT));
				}
				_tmp35_ = structure;
				if (gst_structure_has_field (_tmp35_, "dss")) {
					GeeArrayList* _tmp36_;
					_tmp36_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp36_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_DSS));
				}
				_tmp37_ = structure;
				if (gst_structure_has_field (_tmp37_, "dvb-s")) {
					GeeArrayList* _tmp38_;
					_tmp38_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp38_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_DVBS));
				}
				_tmp39_ = structure;
				if (gst_structure_has_field (_tmp39_, "dvb-s2")) {
					GeeArrayList* _tmp40_;
					_tmp40_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp40_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_DVBS2));
				}
				_tmp41_ = structure;
				if (gst_structure_has_field (_tmp41_, "dvb-h")) {
					GeeArrayList* _tmp42_;
					_tmp42_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp42_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_DVBH));
				}
				_tmp43_ = structure;
				if (gst_structure_has_field (_tmp43_, "isdb-t")) {
					GeeArrayList* _tmp44_;
					_tmp44_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp44_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_ISDBT));
				}
				_tmp45_ = structure;
				if (gst_structure_has_field (_tmp45_, "isdb-s")) {
					GeeArrayList* _tmp46_;
					_tmp46_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp46_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_ISDBS));
				}
				_tmp47_ = structure;
				if (gst_structure_has_field (_tmp47_, "isdb-c")) {
					GeeArrayList* _tmp48_;
					_tmp48_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp48_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_ISDBC));
				}
				_tmp49_ = structure;
				if (gst_structure_has_field (_tmp49_, "atsc")) {
					GeeArrayList* _tmp50_;
					_tmp50_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp50_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_ATSC));
				}
				_tmp51_ = structure;
				if (gst_structure_has_field (_tmp51_, "atsc-mh")) {
					GeeArrayList* _tmp52_;
					_tmp52_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp52_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_ATSCMH));
				}
				_tmp53_ = structure;
				if (gst_structure_has_field (_tmp53_, "dtmb")) {
					GeeArrayList* _tmp54_;
					_tmp54_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp54_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_DTMB));
				}
				_tmp55_ = structure;
				if (gst_structure_has_field (_tmp55_, "cmmb")) {
					GeeArrayList* _tmp56_;
					_tmp56_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp56_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_CMMB));
				}
				_tmp57_ = structure;
				if (gst_structure_has_field (_tmp57_, "dab")) {
					GeeArrayList* _tmp58_;
					_tmp58_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp58_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_DAB));
				}
				_tmp59_ = structure;
				if (gst_structure_has_field (_tmp59_, "dvb-t2")) {
					GeeArrayList* _tmp60_;
					_tmp60_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp60_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_DVBT2));
				}
				_tmp61_ = structure;
				if (gst_structure_has_field (_tmp61_, "turbo")) {
					GeeArrayList* _tmp62_;
					_tmp62_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp62_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_TURBO));
				}
				_tmp63_ = structure;
				if (gst_structure_has_field (_tmp63_, "dvb-c-c")) {
					GeeArrayList* _tmp64_;
					_tmp64_ = self->priv->delsys;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp64_, (gpointer) ((gintptr) DVB_DVB_SRC_DELSYS_SYS_DVBC_ANNEX_C));
				}
				success = TRUE;
				_gst_message_unref0 (msg);
				break;
			}
		} else {
			GstMessage* _tmp65_;
			GstMessageType _tmp66_;
			_tmp65_ = msg;
			_tmp66_ = _tmp65_->type;
			if (_tmp66_ == GST_MESSAGE_ERROR) {
				GError* gerror = NULL;
				gchar* debug = NULL;
				GstMessage* _tmp67_;
				GError* _tmp68_ = NULL;
				gchar* _tmp69_ = NULL;
				GError* _tmp70_;
				const gchar* _tmp71_;
				const gchar* _tmp72_;
				_tmp67_ = msg;
				gst_message_parse_error (_tmp67_, &_tmp68_, &_tmp69_);
				_g_error_free0 (gerror);
				gerror = _tmp68_;
				_g_free0 (debug);
				debug = _tmp69_;
				_tmp70_ = gerror;
				_tmp71_ = _tmp70_->message;
				_tmp72_ = debug;
				g_warning ("Device.vala:340: %s %s", _tmp71_, _tmp72_);
				_g_free0 (debug);
				_g_error_free0 (gerror);
			}
		}
		_gst_message_unref0 (msg);
	}
	_tmp73_ = pipeline;
	gst_element_set_state (_tmp73_, GST_STATE_NULL);
	result = success;
	_g_object_unref0 (bus);
	_g_object_unref0 (pipeline);
	_g_object_unref0 (dvbsrc);
	return result;
}


guint
dvb_device_get_Adapter (DVBDevice* self)
{
	guint result;
	guint _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_Adapter;
	result = _tmp0_;
	return result;
}


static void
dvb_device_set_Adapter (DVBDevice* self,
                        guint value)
{
	g_return_if_fail (self != NULL);
	if (dvb_device_get_Adapter (self) != value) {
		self->priv->_Adapter = value;
		g_object_notify_by_pspec ((GObject *) self, dvb_device_properties[DVB_DEVICE_ADAPTER_PROPERTY]);
	}
}


guint
dvb_device_get_Frontend (DVBDevice* self)
{
	guint result;
	guint _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_Frontend;
	result = _tmp0_;
	return result;
}


static void
dvb_device_set_Frontend (DVBDevice* self,
                         guint value)
{
	g_return_if_fail (self != NULL);
	if (dvb_device_get_Frontend (self) != value) {
		self->priv->_Frontend = value;
		g_object_notify_by_pspec ((GObject *) self, dvb_device_properties[DVB_DEVICE_FRONTEND_PROPERTY]);
	}
}


const gchar*
dvb_device_get_DevFile (DVBDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_DevFile;
	result = _tmp0_;
	return result;
}


static void
dvb_device_set_DevFile (DVBDevice* self,
                        const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, dvb_device_get_DevFile (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_DevFile);
		self->priv->_DevFile = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, dvb_device_properties[DVB_DEVICE_DEV_FILE_PROPERTY]);
	}
}


const gchar*
dvb_device_get_UID (DVBDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_UID;
	result = _tmp0_;
	return result;
}


static void
dvb_device_set_UID (DVBDevice* self,
                    const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, dvb_device_get_UID (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_UID);
		self->priv->_UID = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, dvb_device_properties[DVB_DEVICE_UID_PROPERTY]);
	}
}


const gchar*
dvb_device_get_Name (DVBDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_Name;
	result = _tmp0_;
	return result;
}


static void
dvb_device_set_Name (DVBDevice* self,
                     const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, dvb_device_get_Name (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_Name);
		self->priv->_Name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, dvb_device_properties[DVB_DEVICE_NAME_PROPERTY]);
	}
}


static void
dvb_device_class_init (DVBDeviceClass * klass)
{
	DVBLoggingLogManager* _tmp0_;
	DVBLoggingLogger* _tmp1_;
	dvb_device_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DVBDevicePrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_dvb_device_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_dvb_device_set_property;
	G_OBJECT_CLASS (klass)->finalize = dvb_device_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_DEVICE_ADAPTER_PROPERTY, dvb_device_properties[DVB_DEVICE_ADAPTER_PROPERTY] = g_param_spec_uint ("Adapter", "Adapter", "Adapter", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_DEVICE_FRONTEND_PROPERTY, dvb_device_properties[DVB_DEVICE_FRONTEND_PROPERTY] = g_param_spec_uint ("Frontend", "Frontend", "Frontend", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_DEVICE_DEV_FILE_PROPERTY, dvb_device_properties[DVB_DEVICE_DEV_FILE_PROPERTY] = g_param_spec_string ("DevFile", "DevFile", "DevFile", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_DEVICE_UID_PROPERTY, dvb_device_properties[DVB_DEVICE_UID_PROPERTY] = g_param_spec_string ("UID", "UID", "UID", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DVB_DEVICE_NAME_PROPERTY, dvb_device_properties[DVB_DEVICE_NAME_PROPERTY] = g_param_spec_string ("Name", "Name", "Name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	_tmp0_ = dvb_logging_log_manager_getLogManager ();
	_tmp1_ = dvb_logging_log_manager_getDefaultLogger (_tmp0_);
	dvb_device_log = _tmp1_;
}


static void
dvb_device_instance_init (DVBDevice * self)
{
	self->priv = DVB_DEVICE_GET_PRIVATE (self);
}


static void
dvb_device_finalize (GObject * obj)
{
	DVBDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DVB_TYPE_DEVICE, DVBDevice);
	_g_free0 (self->priv->_DevFile);
	_g_free0 (self->priv->_UID);
	_g_free0 (self->priv->_Name);
	_g_object_unref0 (self->priv->delsys);
	G_OBJECT_CLASS (dvb_device_parent_class)->finalize (obj);
}


GType
dvb_device_get_type (void)
{
	static volatile gsize dvb_device_type_id__volatile = 0;
	if (g_once_init_enter (&dvb_device_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DVBDeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DVBDevice), 0, (GInstanceInitFunc) dvb_device_instance_init, NULL };
		GType dvb_device_type_id;
		dvb_device_type_id = g_type_register_static (G_TYPE_OBJECT, "DVBDevice", &g_define_type_info, 0);
		g_once_init_leave (&dvb_device_type_id__volatile, dvb_device_type_id);
	}
	return dvb_device_type_id__volatile;
}


static void
_vala_dvb_device_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	DVBDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DVB_TYPE_DEVICE, DVBDevice);
	switch (property_id) {
		case DVB_DEVICE_ADAPTER_PROPERTY:
		g_value_set_uint (value, dvb_device_get_Adapter (self));
		break;
		case DVB_DEVICE_FRONTEND_PROPERTY:
		g_value_set_uint (value, dvb_device_get_Frontend (self));
		break;
		case DVB_DEVICE_DEV_FILE_PROPERTY:
		g_value_set_string (value, dvb_device_get_DevFile (self));
		break;
		case DVB_DEVICE_UID_PROPERTY:
		g_value_set_string (value, dvb_device_get_UID (self));
		break;
		case DVB_DEVICE_NAME_PROPERTY:
		g_value_set_string (value, dvb_device_get_Name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_dvb_device_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	DVBDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DVB_TYPE_DEVICE, DVBDevice);
	switch (property_id) {
		case DVB_DEVICE_ADAPTER_PROPERTY:
		dvb_device_set_Adapter (self, g_value_get_uint (value));
		break;
		case DVB_DEVICE_FRONTEND_PROPERTY:
		dvb_device_set_Frontend (self, g_value_get_uint (value));
		break;
		case DVB_DEVICE_DEV_FILE_PROPERTY:
		dvb_device_set_DevFile (self, g_value_get_string (value));
		break;
		case DVB_DEVICE_UID_PROPERTY:
		dvb_device_set_UID (self, g_value_get_string (value));
		break;
		case DVB_DEVICE_NAME_PROPERTY:
		dvb_device_set_Name (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



